/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.defne.hotel.jsf;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.defne.owb.bindings.PojoExecutorProxy;
import org.defne.service.IMessageConstants;
import org.defne.service.Message;
import org.defne.service.MessageFactory;
import org.defne.service.TransactionPolicy;
import org.defne.service.executor.IServiceExecutorProxy;

@Named
@RequestScoped
public class HelloBean {

    private @Inject @PojoExecutorProxy IServiceExecutorProxy pojoExecutor;
    
    private String message;
    
    private String name;
    
    public HelloBean()
    {
	
    }
    
    public String addPerson()
    {
        Message bag = MessageFactory.newMessage("PersonService", "addPerson");
        
        //Add parameters
        bag.putMessageParameter(IMessageConstants.SERVICE_CALLER_TRANSACTION_POLICY, TransactionPolicy.WITH_TRANSACTION);
        bag.putMessageParameter("NAME", this.name);        
        
        //Execute
        bag = this.pojoExecutor.execute(bag);
        
        //Any message
        this.message = bag.getMessageParameter(String.class, "MESSAGE");     
        
        return null;
        
    }
    
    public String sayHello()
    {
    	Message bag = MessageFactory.newMessage("HelloServis", "HelloMethod");
    	bag.putMessageParameter("NAME", this.name);
    	bag.putMessageParameter(IMessageConstants.SERVICE_CALLER_USES_ENTITY_MANAGER_KEY, false);
    	
    	bag = this.pojoExecutor.execute(bag);
    	this.message = bag.getMessageParameter(String.class, "MESSAGE");    	
    	
    	return null;
    }

    public String getMessage()
    {
        return message;
    }

    public void setMessage(String message)
    {
        this.message = message;
    }

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }
}
