/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.defne.hotel.jsf;

import javax.persistence.EntityManager;

import org.defne.jpa.EntityManagerUtil;
import org.defne.owb.PojoServiceExecutor;
import org.defne.service.IMessageConstants;
import org.defne.service.Message;
import org.defne.service.MessageFactory;
import org.defne.service.TransactionPolicy;
import org.defne.service.annotation.Operation;
import org.defne.service.annotation.Service;
import org.defne.utility.exception.DefneException;

@Service
public class PersonService
{
    @Operation
    public static Message addPerson(Message inBag) throws DefneException
    {
        String name = inBag.getMessageParameter(String.class, "NAME");
        EntityManager entityManager = EntityManagerUtil.getEntityManagerFromBag(inBag);
        
        Person person = new Person();
        person.setName(name);
        
        entityManager.persist(person);
        
        Message newBag = MessageFactory.newMessage("OtherPersonService", "addNewPerson");
        newBag.putMessageParameter(IMessageConstants.SERVICE_CALLER_TRANSACTION_POLICY, TransactionPolicy.WITH_TRANSACTION);
        
        //Call other service
        PojoServiceExecutor.execute(newBag);
        
        return inBag;
    }

}
